<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8">
    <meta name="generator" content="GitLab Pages">
    <title>Data Management Hosted on GitLab Pages</title>
    <link rel="stylesheet" href="style.css">
    <style>
      @import url(https://fonts.googleapis.com/css?family=Yanone+Kaffeesatz);
      @import url(https://fonts.googleapis.com/css?family=Droid+Serif:400,700,400italic);
      @import url(https://fonts.googleapis.com/css?family=Ubuntu+Mono:400,700,400italic);

      body { font-family: 'Droid Serif'; }
      h1, h2, h3 {
        font-family: 'Yanone Kaffeesatz';
        font-weight: normal;
      }
      .remark-code, .remark-inline-code { font-family: 'Ubuntu Mono'; }
    </style>
  </head>
  <body>
    <textarea id="source">

class: center, middle

# Data Management

## Motivation

- Preservation - NASA's moon landing was not staged, but the original higher-res tapes and data were erased and reused
- Reproducibility - remake results for a revision of a paper, grant, dissertation, patent application, etc
- Requirements to store clinical data for NIH studies for three years after grant ends
- Protection against hard drive crashes and malware/ransomware
- Digital hording - if you don't have a plan and clean up regularly, you will get buried in disorganized, random folders
- Sharing with other grad students, future you, or external collaborators

---

## Tools for Data and/or Information Management

- Email: best for external communication; attaching file versions is bad
- Duke Box: host a file to share externally (we don't use this much)
- Google: Docs KRN Lab meeting minutes; Calendars for reserving lab resources
- Slack: intra-office communication, Q&amp;A, project teams
- Duke Wiki: how-to's, tutorials, scanner info, logbooks
- Dropbox Business:
  - good: large data, Mac/Windows/Linux, backup, some history versioning, sharing, support for Office docs
- Duke Gitlab:
  - version control
  - code and text files
  - not good for big binary data
- Our Group's RAIDs:
  - good: fast from Linux, works with cluster, backed up
  - bad: sharing, mobile and off-site access

---

## Good Practices for Data/Metadata Storage

- De-identified, nested directory structure
- Timestamp: is it protected PHI?

Metadata notes

- Open
  - You won't have MS Office everywhere. Will OpenOffice work?
  - Do you have privileges to install software on all computers you use?
  - Will you still be using Google Docs in 10 years?
  - Can you read the file into Python, Matlab, Javascript and C easily?
- Text-based structured format
  - Better for `git`, `diff`, and editing with simple tools
  - e.g. `JSON`, `XML`, `YML`, or `CSV`

---

### Example

#### CSV

    "state","region","pop","SATV","SATM","percent","dollars","pay"
    "AL","ESC",4041,470,514,8,3.648,27
    "AK","PAC",550,438,476,42,7.887,43
    "AZ","MTN",3665,445,497,25,4.231,30
    "AR","WSC",2351,470,511,6,3.334,23

---

#### JSON

    [
     {
      "state": "AL",
      "region": "ESC",
      "pop": 4041,
      "SATV": 470,
      "SATM": 514,
      "percent": 8,
      "dollars": 3.648,
      "pay": 27
     },
     {
      "state": "AK",
      "region": "PAC",
      "pop": 550,
      "SATV": 438,
      "SATM": 476,
      "percent": 42,
      "dollars": 7.887,
      "pay": 43
     },
     {
      "state": "AZ",
      "region": "MTN",
      "pop": 3665,
      "SATV": 445,
      "SATM": 497,
      "percent": 25,
      "dollars": 4.231,
      "pay": 30
     },
     {
      "state": "AR",
      "region": "WSC",
      "pop": 2351,
      "SATV": 470,
      "SATM": 511,
      "percent": 6,
      "dollars": 3.334,
      "pay": 23
     }
    ]

---

## Storing Clinical Data, Options:

- Dropbox Business (not Personal)
- RAID drive top-level project folder (e.g. `/getlab/fetal`, not `/home/`)
- Ned D. needs to know about clinical data for backups, and when large sets are added

---

## Lab Notebook

- A good time to change is beginning of a project/year/milestone (e.g. prelim)
- You may prefer digital or paper. Pros and Cons of each
- Keep an index, a color-coding system, and other organizational schemes

---

## Naming Conventions

- Underscores vs spaces in paths and filenames
- Use dates and times that sort  (e.g. 20171107 and 1430)
- If datestamp is protected, replace with a leading-zero-padded serial index

---

## Sharing

Code

- Github: external-facing, public projects, private is not free
- Gitlab: internal, private is free
- Bitbucket: external, private is free
- Ultrasound-specific: [USTB](http://www.ustb.no)

Data

- DOIs can be obtained at [Zenodo](https://zenodo.org/).
- [The Duke Digital Repository (DDR)](https://repository.duke.edu)
  - A service for preserving, securing, and providing access to digital resources
  - Not free for large datasets
- Ultrasound-specific
  - [UFF (format)](http://bme2.mt.elektro.dtu.dk/mediawiki/index.php/Main_Page)
  - [USTB datasets](http://www.ustb.no/ustb-datasets/)

---

## Project Organization via Hashtag

Choose a name for project/class/etc and use that name for:

- Folder in email (external comms)
- Section in your lab notebook/software (notes tieing it all together, documented results and inventions)
- Folder in Dropbox (store data and MS Office)
- Channel in Slack (internal comms, maybe replacement for lab notebook)
- Repository in Gitlab (code version control)

    </textarea>
    <script src="https://remarkjs.com/downloads/remark-latest.min.js">
    </script>
    <script>
      var slideshow = remark.create();
    </script>
  </body>
</html>